//cosh.h

//#pragma warning(disable:4355)


// include the midl generated ITclScript header
#include "../coshps/coshps.h"



class CTclScript : public ITclScript {
 
public:

  /* IUnknown methods */
  STDMETHOD(QueryInterface)(THIS_ REFIID riid, LPVOID  * ppvObj);
  STDMETHOD_(ULONG, AddRef)(THIS);
  STDMETHOD_(ULONG, Release)(THIS);

  /* ITclScript methods */
  STDMETHOD(eval)(BSTR script, BSTR* result, 
	              long* retcode, BSTR* errorinfo);

  CTclScript(void);
  virtual ~CTclScript (void);

  static CTclScript * Create(Tcl_Interp* interp);


 private:
	LONG m_cRef;
	Tcl_Interp* m_interp;
};


// the CTclScript Class Factory
//
class CTclScriptCF : public IClassFactory {
public:
    static IClassFactory * Create();

    STDMETHOD(QueryInterface)(REFIID riid, void * * ppv);
    STDMETHOD_(ULONG, AddRef)(void);
    STDMETHOD_(ULONG, Release)(void);

    STDMETHOD(CreateInstance)(
      IUnknown * punkOuter, REFIID riid, void * * ppv);
    STDMETHOD(LockServer)(BOOL fLock);

    CTclScriptCF() { m_refs = 1; }

private:
    ULONG m_refs;
};

extern BOOL InitCom(Tcl_Interp* interp);
extern BOOL UnInitCom(void);

extern CTclScript * g_pTclScript;

